#include "Helpers.h"

UBYTE CheckRectCollision(Rect* rect1, Rect* rect2)
{
    return (rect1->x < (rect2->x + rect2->width)
    && rect2->x < (rect1->x + rect1->width)
    && rect1->y < (rect2->y + rect2->height)
    && rect2->y < (rect1->y + rect1->height));
}

void Wait(UINT8 numloops)
{
    for(waitI = 0; waitI < numloops; waitI++)
    {
        wait_vbl_done();
    }     
}

void FadeOut(UINT8 wait)
{
    for(i = 4; i >= 1; --i)
    {
         // Offset this by one to avoid negative numbers
		SetFadePalette(i - 1);
		Wait(wait);
	}
}

void FadeIn(UINT8 wait)
{
	for(i = 0; i < 4; ++i)
    {
		SetFadePalette(i);						
		Wait(wait);
	}
}

void SetFadePalette(UINT8 index)
{
    if(index == 0) BGP_REG = OBP0_REG = OBP1_REG = 0xE4;
    else if(index == 1) BGP_REG = OBP0_REG = OBP1_REG = 0xF9;
    else if(index == 2) BGP_REG = OBP0_REG = OBP1_REG = 0xFE;
    else if(index == 3) BGP_REG = OBP0_REG = OBP1_REG = 0xFF;
}

UINT8 Clamp(UINT8 value, UINT8 min, UINT8 max)
{
    if (value > max)
    {
        return max;
    }
    else if(value < min)
    {
        return min;
    }
    return value;
}

UINT8 Wrap(UINT8 value, UINT8 min, UINT8 max)
{
    if (value > max)
    {
        return min;
    }
    else if(value < min)
    {
        return max;
    }
    return value;
}

void UINT8ToText(UINT8 num, unsigned char *numberTiles)
{
    numberTiles[0] = 0x80;
    numberTiles[1] = 0x80;
    numberTiles[2] = 0x80;

    i = 2;

    while (num > 0)
    {
        j = num % 10;
        num /= 10;

        if(j == 0) numberTiles[i] = 0x9B;
        else if(j == 1) numberTiles[i] = 0x9C;
        else if(j == 2) numberTiles[i] = 0x9D;
        else if(j == 3) numberTiles[i] = 0x9E;
        else if(j == 4) numberTiles[i] = 0x9F;
        else if(j == 5) numberTiles[i] = 0xA0;
        else if(j == 6) numberTiles[i] = 0xA1;
        else if(j == 7) numberTiles[i] = 0xA2;
        else if(j == 8) numberTiles[i] = 0xA3;
        else if(j == 9) numberTiles[i] = 0xA4;

        --i;
    }
}

void WaitForRandom()
{
	waitpad(J_START);
	waitpadup();
	initarand(DIV_REG); 
}

UINT8 GetRandom(UINT8 maxValue)
{
    i = 0;
    j = maxValue + 1;

    // Try to get valid random 10 times due bug
    while ((j < 0 || j > maxValue) && i < 10)
    {
        j = ((UINT8)rand()) % maxValue;
        ++i;
    }

    // If random is still invalid, return 0
    if(j < 0 || j > maxValue)
    {
        return 0;
    }

    return j;
}