#include <gb/gb.h>
#include "Helpers.h"

#ifndef SPRITESYSTEM
#define SPRITESYSTEM

typedef struct Sprite
{
	UINT8 id;
	Rect rect;
} Sprite;

typedef struct MetaSprite1x2
{
	UINT8 ids[2];
	Rect rect;
} MetaSprite1x2;

typedef struct MetaSprite2x1
{
	UINT8 ids[2];
	Rect rect;
} MetaSprite2x1;

typedef struct MetaSprite2x2
{
	UINT8 ids[4];
	Rect rect;
} MetaSprite2x2;

typedef struct MetaSprite4x4
{
	UINT8 ids[16];
	Rect rect;
} MetaSprite4x4;

void InitSprite(Sprite* sprite,
UINT8 id, UINT8 mem, UINT8 x, UINT8 y);

void InitMetaSprite1x2(MetaSprite1x2* metaSprite1x2,
UINT8 id1, UINT8 mem, UINT8 x, UINT8 y);

void InitMetaSprite2x1(MetaSprite2x1* metaSprite2x1,
UINT8 id1, UINT8 mem, UINT8 x, UINT8 y);

void InitMetaSprite2x2(MetaSprite2x2* metaSprite2x2,
UINT8 id1, UINT8 mem, UINT8 x, UINT8 y);

void InitMetaSprite4x4(MetaSprite4x4* metaSprite4x4,
UINT8 id1, UINT8 mem, UINT8 x, UINT8 y);

void MoveSprite(Sprite* sprite, UINT8 x, UINT8 y);
void MoveMetaSprite1x2(MetaSprite1x2* metaSprite1x2, UINT8 x, UINT8 y);
void MoveMetaSprite1x2FlipY(MetaSprite1x2* metaSprite1x2, UINT8 x, UINT8 y);
void MoveMetaSprite2x1(MetaSprite2x1* metaSprite2x1, UINT8 x, UINT8 y);
void MoveMetaSprite2x1FlipX(MetaSprite2x1* metaSprite2x1, UINT8 x, UINT8 y);
void MoveMetaSprite2x2FlipY(MetaSprite2x2* metaSprite2x2, UINT8 x, UINT8 y);
void MoveMetaSprite2x2(MetaSprite2x2* metaSprite2x2, UINT8 x, UINT8 y);
void MoveMetaSprite2x2FlipX(MetaSprite2x2* metaSprite2x2, UINT8 x, UINT8 y);
void MoveMetaSprite4x4(MetaSprite4x4* metaSprite4x4, UINT8 x, UINT8 y);

#endif