#include "main.h"

void main()
{
    DISPLAY_ON;
    SHOW_BKG;
    SHOW_SPRITES;
    LoadTitle();

    while(1)
    {
        switch (gameState)
        {
            // Title
            case 0:
                WaitForRandom();
                LoadBattle();
                break;
            
            // Lore
            case 1:
                waitpad(J_START);
                waitpadup();
                LoadShop();
                break;

            // Shop
            case 2:
                ShopLoop();
                break;

            // Battle
            case 3:
                BattleLoop();
                break;
            
            // Game Over / Outro
            case 4:
            case 5:
                waitpad(J_START);
                waitpadup();
                LoadTitle();
                break;
        }

    }
}

void LoadTitle()
{
    FadeIn(10);
    sacrifice = 250;
    health = 50;
    battleNo = gameState = weaponsUnlocked = 0;
    set_bkg_data(0, 109, TitleBG2_data);
    set_bkg_tiles(0, 0, 20, 18, TitleBG2_map);
    move_bkg(0, 0);
    FadeOut(10);
}

void LoadLore()
{
    FadeIn(10);
    gameState = 1;
    set_bkg_data(0, 72, ShopTiles);
    set_bkg_tiles(0, 0, 20, 18, LoreBG);
    move_bkg(0, 0);
    FadeOut(10);
}

void LoadShop()
{
    FadeIn(10);
    gameState = 2;
    currentSelection = 1;
    set_bkg_data(0, 70, ShopTiles);
    set_bkg_tiles(0, 0, 20, 18, ShopBG);
    move_bkg(0, 0);
    set_sprite_data(0, 5, ShopSelectionTiles);
    set_sprite_data(5, 38, Alpha);
    for(i = 0; i < 3; ++i)
    {
        InitSprite(&hpSprites[i], 32, 4+i, 16 + SPRITE_SIZE * i, 62);
        InitSprite(&sacrificeSprites[i], 32, 7+i, 138 + SPRITE_SIZE * i, 62);
    }
    DisplayShopHp();
    InitMetaSprite1x2(&selectionLeft, 3, 0, 24, 0);
    InitMetaSprite1x2(&weaponSpearVer, 1, 2, 146, 0);
    MoveShopSelection();
    FadeOut(10);
}

void LoadBattle()
{
    FadeIn(10);
    gameState = 3;
    ++battleNo;
    if(battleNo > 3) battleNo = 2;
    currentSelection = weaponsUnlocked;
    stageScrollX = START_POS;
    stageScrollY = START_POS;
    enemyDirTimer = 0;
    enemyDirection = 0;
    enemyPosX = ENEMY_START_POS;
    enemyPosY = ENEMY_START_POS;
    enemyHealth = BATTLE_NO_HPS[battleNo-1];
    dashFrames = attackFrames = animFrame = damageFrames = 0;

    set_bkg_data(0, 41, BattleBGTiles);
    set_bkg_tiles(0, 0, 32, 32, battleNo < 3 ? BattleBGMap : BattleBGMap2);
    set_sprite_data(0, 58, BattleTiles);
    InitMetaSprite2x2(&player, 1, 0, stageScrollX, stageScrollY);
    InitMetaSprite2x2(&door, 45, 4, 128, 32);
    set_sprite_tile(5, 45);
    set_sprite_tile(6, 46);
    set_sprite_tile(7, 46);
    set_sprite_prop(door.ids[1], get_sprite_prop(door.ids[1]) | S_FLIPX);
    set_sprite_prop(door.ids[3], get_sprite_prop(door.ids[3]) | S_FLIPX);
    InitSprite(&weaponDagger, 48, 8, 0, 200);
    InitMetaSprite1x2(&weaponSpearHor, 50, 9, 0, 200);
    InitMetaSprite2x1(&weaponSpearVer, 52, 11, 0, 200);
    InitMetaSprite2x2(&weaponSword, 54, 13, 0, 200);

    if(battleNo == 1)
    {
        battleState = 1;
        set_sprite_data(58, 25, EnemyTiles1);
        InitMetaSprite2x2(&enemy2x2, 58, 17, enemyPosX, enemyPosY);
    }
    else if (battleNo == 2)
    {
        battleState = 2;
        set_sprite_data(58, 25, EnemyTiles1);
        InitMetaSprite2x2(&enemy2x2, 58, 17, enemyPosX, enemyPosY);
    }
    else if (battleNo == 3)
    {
        battleState = 3;
        set_sprite_data(59, 41, EnemyTiles2);
        InitMetaSprite4x4(&enemy4x4, 58, 17, enemyPosX, enemyPosY);
    }
    
    set_win_data(128, 38, Alpha);
    move_win(7, 136);
    DisplayHp();
    SHOW_WIN;
    FadeOut(10);
}

void LoadGameOver()
{
    FadeIn(10);
    gameState = 4;
    set_bkg_data(0, 70, ShopTiles);
    set_bkg_tiles(0, 0, 20, 18, DieBG);
    move_bkg(0, 0);
    FadeOut(10);
}

void LoadOutro()
{
    FadeIn(10);
    gameState = 5;
    EndBattle();
    set_bkg_data(0, 70, ShopTiles);
    set_bkg_tiles(0, 0, 20, 18, WinBG);
    move_bkg(0, 0);
    FadeOut(10);
}

void ShopLoop()
{

    if(joypad() & J_UP)
    {
        --currentSelection;
        if(weaponsUnlocked == 2 && currentSelection == 2) --currentSelection;
        currentSelection = Wrap(currentSelection, 1, 3);
        MoveShopSelection();
        Wait(20);
    }
    else if(joypad() & J_DOWN)
    {
        ++currentSelection;
        if(weaponsUnlocked == 2 && currentSelection == 2) ++currentSelection;
        currentSelection = Wrap(currentSelection, 1, 3);
        MoveShopSelection();
        Wait(20);
    }

    if(joypad() & J_A)
    {
        switch (currentSelection)
        {
            // Offer
            case 1:
                if(health > 1)
                {
                    --health;
                    --sacrifice;
                    DisplayShopHp();

                    if(sacrifice == 0)
                    {
                        LoadOutro();
                        return;
                    }

                    Wait(5);
                }
                break;

            // New weapon
            case 2:
                if(health > 50 && weaponsUnlocked <= 4)
                {
                    health -= 50;
                    weaponsUnlocked++;
                    DisplayShopHp();
                }
                break;

            // Continue
            case 3:
                LoadBattle();
                break;
        }
    }
}

void MoveShopSelection()
{
    if(currentSelection == 1)
    {
        MoveMetaSprite1x2(&selectionLeft, selectionLeft.rect.x, 100);
        MoveMetaSprite1x2(&weaponSpearVer, weaponSpearVer.rect.x, 100);
    }
    else if(currentSelection == 2)
    {
        MoveMetaSprite1x2(&selectionLeft, selectionLeft.rect.x, 116);
        MoveMetaSprite1x2(&weaponSpearVer, weaponSpearVer.rect.x, 116);
    }
    else if(currentSelection == 3)
    {
        MoveMetaSprite1x2(&selectionLeft, selectionLeft.rect.x, 132);
        MoveMetaSprite1x2(&weaponSpearVer, weaponSpearVer.rect.x, 132);
    }
}

void BattleLoop()
{
    if(joypad() & J_START)
    {
        Wait(1);
        SetFadePalette(1);
        waitpadup(J_START);
        waitpad(J_START);
        waitpadup(J_START);
        SetFadePalette(0);
    }

    PlayerLoop();

    switch (battleState)
    {
        // Battle end
        case 0:
            if(CheckRectCollision(&player.rect, &door.rect))
            {
                EndBattle();
                if(battleNo == 1)
                {
                    LoadLore();
                }
                else
                {
                    LoadShop();
                }
                return;
            }
        break;
    
        // Battle
        default:
            EnemyLoop();
            break;
    }

    ++animFrame;
    animFrame = Wrap(animFrame, 0, 4);

    // Game speed
    Wait(3);
}

void PlayerLoop()
{
    if(dashFrames == 0 && attackFrames == 0)
    {
        j = joypad();
        if(j & J_SELECT)
        {
            waitpadup();
            ++currentSelection;
            if(currentSelection > weaponsUnlocked) currentSelection = 0;
        }

        if(j & J_UP)
        {
            playerDirection = 0;
            MovePlayer(PLAYER_SPEED);
        }
        else if(j & J_DOWN)
        {
            playerDirection = 2;
            MovePlayer(PLAYER_SPEED);
         }
        else if(j & J_LEFT)
        {
            playerDirection = 1;
            MovePlayer(PLAYER_SPEED);
        }
        else if(j & J_RIGHT)
        {
            playerDirection = 3;
            MovePlayer(PLAYER_SPEED);
        }
        else
        {
            IdlePlayer();
        }

        if(j & J_A)
        {
            animFrame = 0;
            dashFrames = 1;
        }
        else if(j & J_B)
        {
            attackFrames = 1;
            if(currentSelection == 0) 
            {
                if(playerDirection == 0)
                {
                    set_sprite_prop(weaponDagger.id, get_sprite_prop(weaponDagger.id) & ~S_FLIPY);
                    set_sprite_tile(weaponDagger.id, 49);
                    MoveSprite(&weaponDagger, player.rect.x + 8, player.rect.y - 8);
                }
                else if(playerDirection == 1)
                {
                    set_sprite_prop(weaponDagger.id, get_sprite_prop(weaponDagger.id) | S_FLIPX);
                    set_sprite_tile(weaponDagger.id, 48);
                    MoveSprite(&weaponDagger, player.rect.x - 8, player.rect.y + 4);
                }
                else if(playerDirection == 2)
                {
                    set_sprite_prop(weaponDagger.id, get_sprite_prop(weaponDagger.id) | S_FLIPY);
                    set_sprite_tile(weaponDagger.id, 49);
                    MoveSprite(&weaponDagger, player.rect.x, player.rect.y + 16);
                }
                else if(playerDirection == 3)
                {
                    set_sprite_prop(weaponDagger.id, get_sprite_prop(weaponDagger.id) & ~S_FLIPX);
                    set_sprite_tile(weaponDagger.id, 48);
                    MoveSprite(&weaponDagger, player.rect.x + 16, player.rect.y + 4);
                }

                if(battleState < 3)
                {
                    if(CheckRectCollision(&weaponDagger.rect, &enemy2x2.rect))
                    {
                        EnemyTakeDamage(10);
                    }
                }
                else
                {
                    if(CheckRectCollision(&weaponDagger.rect, &enemy4x4.rect))
                    {
                        EnemyTakeDamage(10);
                    } 
                }
            }
            else if(currentSelection == 1) 
            {
                if(playerDirection == 0)
                {
                    set_sprite_prop(weaponSpearVer.ids[0], get_sprite_prop(weaponSpearVer.ids[0]) & ~S_FLIPY);
                    set_sprite_prop(weaponSpearVer.ids[1], get_sprite_prop(weaponSpearVer.ids[1]) & ~S_FLIPY);
                    MoveMetaSprite1x2(&weaponSpearVer, player.rect.x + 8, player.rect.y - 16);
                }
                else if(playerDirection == 1)
                {
                    set_sprite_prop(weaponSpearHor.ids[0], get_sprite_prop(weaponSpearHor.ids[0]) | S_FLIPX);
                    set_sprite_prop(weaponSpearHor.ids[1], get_sprite_prop(weaponSpearHor.ids[1]) | S_FLIPX);
                    MoveMetaSprite2x1FlipX(&weaponSpearHor, player.rect.x - 16, player.rect.y + 4);
                }
                else if(playerDirection == 2)
                {
                    set_sprite_prop(weaponSpearVer.ids[0], get_sprite_prop(weaponSpearVer.ids[0]) | S_FLIPY);
                    set_sprite_prop(weaponSpearVer.ids[1], get_sprite_prop(weaponSpearVer.ids[1]) | S_FLIPY);
                    MoveMetaSprite1x2FlipY(&weaponSpearVer, player.rect.x, player.rect.y + 16);
                }
                else if(playerDirection == 3)
                {
                    set_sprite_prop(weaponSpearHor.ids[0], get_sprite_prop(weaponSpearHor.ids[0]) & ~S_FLIPX);
                    set_sprite_prop(weaponSpearHor.ids[1], get_sprite_prop(weaponSpearHor.ids[1]) & ~S_FLIPX);
                    MoveMetaSprite2x1(&weaponSpearHor, player.rect.x + 16, player.rect.y + 4);
                }

                if(battleState < 3)
                {
                    if(CheckRectCollision(&weaponSpearVer.rect, &enemy2x2.rect))
                    {
                        EnemyTakeDamage(10);
                    }
                    if(CheckRectCollision(&weaponSpearHor.rect, &enemy2x2.rect))
                    {
                        EnemyTakeDamage(10);
                    }
                }
                else
                {
                    if(CheckRectCollision(&weaponSpearVer.rect, &enemy4x4.rect))
                    {
                        EnemyTakeDamage(10);
                    } 
                     if(CheckRectCollision(&weaponSpearHor.rect, &enemy4x4.rect))
                    {
                        EnemyTakeDamage(10);
                    } 
                }

            }
            else if(currentSelection == 2)  
            {
                if(playerDirection == 0)
                {
                    for(i = 0; i < 4; ++i)
                    {
                        set_sprite_prop(weaponSword.ids[i], get_sprite_prop(weaponSword.ids[i]) & ~S_FLIPX);
                        set_sprite_prop(weaponSword.ids[i], get_sprite_prop(weaponSword.ids[i]) | S_FLIPY);
                    }
                    MoveMetaSprite2x2FlipY(&weaponSword, player.rect.x, player.rect.y - 16);
                }
                else if(playerDirection == 1)
                {
                    for(i = 0; i < 4; ++i)
                    {
                        set_sprite_prop(weaponSword.ids[i], get_sprite_prop(weaponSword.ids[i]) & ~S_FLIPY);
                        set_sprite_prop(weaponSword.ids[i], get_sprite_prop(weaponSword.ids[i]) | S_FLIPX);
                    }
                    MoveMetaSprite2x2FlipX(&weaponSword, player.rect.x - 16, player.rect.y);
                }
                else if(playerDirection == 2)
                {
                    for(i = 0; i < 4; ++i)
                    {
                        set_sprite_prop(weaponSword.ids[i], get_sprite_prop(weaponSword.ids[i]) & ~S_FLIPY);
                        set_sprite_prop(weaponSword.ids[i], get_sprite_prop(weaponSword.ids[i]) | S_FLIPX);
                    }
                    MoveMetaSprite2x2FlipX(&weaponSword, player.rect.x, player.rect.y + 16);
                }
                else if(playerDirection == 3)
                {
                    for(i = 0; i < 4; ++i)
                    {
                        set_sprite_prop(weaponSword.ids[i], get_sprite_prop(weaponSword.ids[i]) & ~S_FLIPX & ~S_FLIPY);
                    }
                    MoveMetaSprite2x2(&weaponSword, player.rect.x + 16, player.rect.y);
                }

                if(battleState < 3)
                {
                    if(CheckRectCollision(&weaponSword.rect, &enemy2x2.rect))
                    {
                        EnemyTakeDamage(10);
                    }
                }
                else
                {
                   if(CheckRectCollision(&weaponSword.rect, &enemy4x4.rect))
                    {
                        EnemyTakeDamage(10);
                    } 
                }
            }
        }

    }
    else if(dashFrames > 0)
    {
        MovePlayer(PLAYER_DASH_SPEED);

        ++dashFrames;
        if(dashFrames >= 8)
        {
            dashFrames = 0;
        }
        else
        {
            if(animFrame <= 1)
            {
                for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(player.ids[i], 37+i);
                }
                
            }
            else 
            {
                for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(player.ids[i], 41+i);
                }
            }
        }
    }
    else if(attackFrames > 0)
    {
        ++attackFrames;
        if(attackFrames >= 4)
        {
            if(currentSelection == 0) MoveSprite(&weaponDagger, 0, 200);
            else if(currentSelection == 1)
            {
                MoveMetaSprite2x1(&weaponSpearHor, 0, 200);
                MoveMetaSprite1x2(&weaponSpearVer, 0, 200);
            }
            else if(currentSelection == 2) MoveMetaSprite2x2(&weaponSword, 0, 200);
            attackFrames = 0;
        }
    }
    
    if(damageFrames > 0)
    {
        --damageFrames;

        if(damageFrames % 2)
        {
            for(i = 0; i < 4; ++i)
            {
                set_sprite_tile(player.ids[i], 0);
            }
        }
    }
}

void MovePlayer(UINT8 speed)
{
    if(playerDirection == 0)
    {
        if((stageScrollY - speed) > battleStageMinY)
        {
            if(animFrame <= 2)
            {
                for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(player.ids[i], 1+i);
                }
            }
            else
            {
                for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(player.ids[i], 5+i);
                }
            }

            for(i = 0; i < 4; ++i)
            {
                set_sprite_prop(player.ids[i], get_sprite_prop(player.ids[i]) & ~S_FLIPX);
            }

            MoveMetaSprite2x2(&player, player.rect.x, player.rect.y);

            scroll_bkg(0, -speed);
            stageScrollY -= speed;
            MoveMetaSprite2x2(&door, door.rect.x, door.rect.y + speed);
            if(battleNo < 3) MoveMetaSprite2x2(&enemy2x2, enemy2x2.rect.x, enemy2x2.rect.y + speed);
            else MoveMetaSprite4x4(&enemy4x4, enemy4x4.rect.x, enemy4x4.rect.y + speed);
        }
    }
    else if(playerDirection == 1)
    {
        if((stageScrollX - speed) > battleStageMinX)
        {
            if(animFrame <= 2)
            {
                for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(player.ids[i], 9+i);
                }
            }
            else
            {
                for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(player.ids[i], 13+i);
                }
            }

            for(i = 0; i < 4; ++i)
            {
                set_sprite_prop(player.ids[i], get_sprite_prop(player.ids[i]) | S_FLIPX);
            }

            MoveMetaSprite2x2FlipX(&player, player.rect.x, player.rect.y);

            scroll_bkg(-speed, 0);
            stageScrollX -= speed;
            MoveMetaSprite2x2(&door, door.rect.x + speed, door.rect.y);
            if(battleNo < 3) MoveMetaSprite2x2(&enemy2x2, enemy2x2.rect.x + speed, enemy2x2.rect.y);
            else MoveMetaSprite4x4(&enemy4x4, enemy4x4.rect.x + speed, enemy4x4.rect.y);
        }
    }
    else if(playerDirection == 2)
    {
        if((stageScrollY + speed) < battleStageMaxY)
        {
            if(animFrame <= 2)
            {
                for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(player.ids[i], 17+i);
                }
            }
            else
            {
                for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(player.ids[i], 21+i);
                }
            }

            for(i = 0; i < 4; ++i)
            {
                set_sprite_prop(player.ids[i], get_sprite_prop(player.ids[i]) & ~S_FLIPX);
            }

            MoveMetaSprite2x2(&player, player.rect.x, player.rect.y);

            scroll_bkg(0, speed);
            stageScrollY += speed;
            MoveMetaSprite2x2(&door, door.rect.x, door.rect.y - speed);
            if(battleNo < 3) MoveMetaSprite2x2(&enemy2x2, enemy2x2.rect.x, enemy2x2.rect.y - speed);
            else MoveMetaSprite4x4(&enemy4x4, enemy4x4.rect.x, enemy4x4.rect.y - speed);
        }
    }
    else if(playerDirection == 3)
    {
        if((stageScrollX + speed) < battleStageMaxX)
        {
            if(animFrame <= 2)
            {
                for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(player.ids[i], 9+i);
                }
            }
            else
            {
                for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(player.ids[i], 13+i);
                }
            }

            for(i = 0; i < 4; ++i)
            {
                set_sprite_prop(player.ids[i], get_sprite_prop(player.ids[i]) & ~S_FLIPX);
            }

            MoveMetaSprite2x2(&player, player.rect.x, player.rect.y);

            scroll_bkg(speed, 0);
            stageScrollX += speed;
            MoveMetaSprite2x2(&door, door.rect.x - speed, door.rect.y);
            if(battleNo < 3) MoveMetaSprite2x2(&enemy2x2, enemy2x2.rect.x - speed, enemy2x2.rect.y);
            else MoveMetaSprite4x4(&enemy4x4, enemy4x4.rect.x - speed, enemy4x4.rect.y);
        }
    }
}

void IdlePlayer()
{
    if(playerDirection == 0)
    {
        for(i = 0; i < 4; ++i)
        {
            set_sprite_tile(player.ids[i], 25+i);
        }
    }
    else if(playerDirection == 2)
    {
        for(i = 0; i < 4; ++i)
        {
            set_sprite_tile(player.ids[i], 33+i);
        }
    }
    else
    {
        for(i = 0; i < 4; ++i)
        {
            set_sprite_tile(player.ids[i], 29+i);
        }
    }
}

void TakeDamage(UINT8 amount)
{
    if(damageFrames == 0)
    {
        dashFrames = 0;
        damageFrames = 8;

        health -= amount;
        if(health <= 0 || health > maxHealth)
        {
            health = 0;
            EndBattle();
            LoadGameOver();
        }
        DisplayHp();
    }
}

void EnemyLoop()
{
    if(enemyDirTimer == 0)
    {
        enemyDirection = GetRandom(BATTLE_NO_DIRS[battleNo-1]);
        if(enemyDirection > 3)
        {
            EnemyDirTowardsPlayer();
        }
        enemyDirTimer = 4 + GetRandom(BATTLE_NO_WALKS[battleNo-1]);
    }
    else
    {
        --enemyDirTimer;
    }

    si = sj = j = 0;

    if(battleState < 3)
    {
        MoveEnemy2x2(battleNo == 1 ? ENEMY1_SPEED : ENEMY2_SPEED);

        if(CheckRectCollision(&player.rect, &enemy2x2.rect))
        {
            MovePlayer(-PLAYER_DASH_SPEED);
            TakeDamage(7);
        }
    }
    else
    {
        MoveEnemy4x4(ENEMY2_SPEED);

        if(CheckRectCollision(&player.rect, &enemy4x4.rect))
        {
            MovePlayer(-PLAYER_DASH_SPEED);
            TakeDamage(9);
        }
    }

    if(enemyDamageFrames > 0)
    {
        --enemyDamageFrames;

        if(enemyDamageFrames % 2)
        {
            if(battleState < 3)
            {
                for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(enemy2x2.ids[i], 0);
                }
            }
            else 
            {
                for(i = 0; i < 16; ++i)
                {
                    set_sprite_tile(enemy4x4.ids[i], 0);
                }
            }
            
        }
    }    
}

void MoveEnemy2x2(UINT8 speed)
{
    if(enemyDirection == 0)
    {
        if((enemyPosY - speed) > battleStageMinY)
        {
            if(animFrame <= 2)
            {
                for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(enemy2x2.ids[i], 59+i);
                }
            }
            else
            {
                for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(enemy2x2.ids[i], 63+i);
                }
            }

            for(i = 0; i < 4; ++i)
            {
                set_sprite_prop(enemy2x2.ids[i], get_sprite_prop(enemy2x2.ids[i]) & ~S_FLIPX);
            }

            enemyPosY -= speed;
            sj = -speed;
            j = 0;
        }
    }
    else if(enemyDirection == 1)
    {
        if((enemyPosX - speed) > battleStageMinX)
        {
            if(animFrame <= 2)
            {
                for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(enemy2x2.ids[i], 67+i);
                }
            }
            else
            {
               for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(enemy2x2.ids[i], 71+i);
                }
            }

            for(i = 0; i < 4; ++i)
            {
                set_sprite_prop(enemy2x2.ids[i], get_sprite_prop(enemy2x2.ids[i]) | S_FLIPX);
            }

            enemyPosX -= speed;
            si = -speed;
            j = 1;
        }
    }
    else if(enemyDirection == 2)
    {
        if((enemyPosY + speed) < battleStageMaxY)
        {
            if(animFrame <= 2)
            {
                for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(enemy2x2.ids[i], 75+i);
                }
            }
            else
            {
                for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(enemy2x2.ids[i], 79+i);
                }
            }

            for(i = 0; i < 4; ++i)
            {
                set_sprite_prop(enemy2x2.ids[i], get_sprite_prop(enemy2x2.ids[i]) & ~S_FLIPX);
            }

            enemyPosY += speed;
            sj = speed;
            j = 0;
        }
    }
    else if(enemyDirection == 3)
    {
        if((enemyPosX + speed) < battleStageMaxX)
        {
            if(animFrame <= 2)
            {
                for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(enemy2x2.ids[i], 67+i);
                }
            }
            else
            {
                for(i = 0; i < 4; ++i)
                {
                    set_sprite_tile(enemy2x2.ids[i], 71+i);
                }
            }

            for(i = 0; i < 4; ++i)
            {
                set_sprite_prop(enemy2x2.ids[i], get_sprite_prop(enemy2x2.ids[i]) & ~S_FLIPX);
            }
 
            enemyPosX += speed;
            si = speed;
            j = 0;
        }
    }
    
    if(j == 0)
    {
        MoveMetaSprite2x2(&enemy2x2, enemy2x2.rect.x + si, enemy2x2.rect.y + sj);
    }
    else
    {
        MoveMetaSprite2x2FlipX(&enemy2x2, enemy2x2.rect.x + si, enemy2x2.rect.y + sj);
    }
}

void MoveEnemy4x4(UINT8 speed)
{
    if(enemyDirection == 0)
    {
        if((enemyPosY - speed) > battleStageMinY)
        {
            if(animFrame <= 2)
            {
                for(i = 0; i < 16; ++i)
                {
                    set_sprite_prop(enemy4x4.ids[i], get_sprite_prop(enemy4x4.ids[i]) & ~S_FLIPX);
                    set_sprite_tile(enemy4x4.ids[i], DINO_UP1[i]);
                }
                j = 0;
            }
            else
            {
                for(i = 0; i < 16; ++i)
                {
                    set_sprite_prop(enemy4x4.ids[i], get_sprite_prop(enemy4x4.ids[i]) | S_FLIPX);
                    set_sprite_tile(enemy4x4.ids[i], DINO_UP1[i]);
                }
                j = 1;
            }

            sj = -speed;
            enemyPosY -= speed;
        }
    }
    else if(enemyDirection == 1)
    {
        if((enemyPosX - speed) > battleStageMinX)
        {
            if(animFrame <= 2)
            {
                for(i = 0; i < 16; ++i)
                {
                    set_sprite_tile(enemy4x4.ids[i], DINO_LEFT1[i]);
                }
            }
            else
            {
                for(i = 0; i < 16; ++i)
                {
                    set_sprite_tile(enemy4x4.ids[i], DINO_LEFT2[i]);
                }
            }

            for(i = 0; i < 16; ++i)
            {
                set_sprite_prop(enemy4x4.ids[i], get_sprite_prop(enemy4x4.ids[i]) | S_FLIPX);
            }

            j = 1;
            si = -speed;
            enemyPosX -= speed;
        }
    }
    else if(enemyDirection == 2)
    {
        if((enemyPosY + speed) < battleStageMaxY)
        {
            if(animFrame <= 2)
            {
                for(i = 0; i < 16; ++i)
                {
                    set_sprite_prop(enemy4x4.ids[i], get_sprite_prop(enemy4x4.ids[i]) & ~S_FLIPX);
                    set_sprite_tile(enemy4x4.ids[i], DINO_DOWN1[i]);
                }
                j = 0;
            }
            else
            {
                for(i = 0; i < 16; ++i)
                {
                    set_sprite_prop(enemy4x4.ids[i], get_sprite_prop(enemy4x4.ids[i]) | S_FLIPX);
                    set_sprite_tile(enemy4x4.ids[i], DINO_DOWN1[i]);
                }
                j = 1;
            }

            sj = speed;
            enemyPosY += speed;
        }
    }
    else if(enemyDirection == 3)
    {
        if((enemyPosX + speed) < battleStageMaxX)
        {
            if(animFrame <= 2)
            {
                for(i = 0; i < 16; ++i)
                {
                    set_sprite_tile(enemy4x4.ids[i], DINO_LEFT1[i]);
                }
            }
            else
            {
                for(i = 0; i < 16; ++i)
                {
                    set_sprite_tile(enemy4x4.ids[i], DINO_LEFT2[i]);
                }
            }

            for(i = 0; i < 16; ++i)
            {
                set_sprite_prop(enemy4x4.ids[i], get_sprite_prop(enemy4x4.ids[i]) & ~S_FLIPX);
            }

            j = 0;
            si = speed;
            enemyPosX += speed;
        }
    }
    
    if(j == 0)
    {
        MoveMetaSprite4x4(&enemy4x4, enemy4x4.rect.x + si, enemy4x4.rect.y + sj);
    }
    else
    {
        MoveMetaSprite4x4FlipX(&enemy4x4, enemy4x4.rect.x + si, enemy4x4.rect.y + sj);
    }

}

void EnemyDirTowardsPlayer()
{
    i = GetRandom(2);

    if(i == 0)
    {
        if(enemyPosX < stageScrollX)
        {
            enemyDirection = 3;
        }
        else if(enemyPosX > stageScrollX)
        {
            enemyDirection = 1;
        }
        else if(enemyPosY < stageScrollY)
        {
            enemyDirection = 2;
        }
        else if(enemyPosY > stageScrollY)
        {
            enemyDirection = 0;
        }
    }
    else
    {
        if(enemyPosY < stageScrollY)
        {
            enemyDirection = 2;
        }
        else if(enemyPosY > stageScrollY)
        {
            enemyDirection = 0;
        }
        else if(enemyPosX < stageScrollX)
        {
            enemyDirection = 3;
        }
        else if(enemyPosX > stageScrollX)
        {
            enemyDirection = 1;
        }
    }

}

void EnemyTakeDamage(UINT8 amount)
{
    if(enemyDamageFrames == 0)
    {
        enemyDamageFrames = 8;

        health += amount;
        if(health > maxHealth) health = maxHealth;

        enemyHealth -= amount;
        if(enemyHealth < 0 || enemyHealth > 200) enemyHealth = 0;

        DisplayHp();

        if(enemyHealth == 0)
        {
            if(battleState < 3)
            {
                for(i = 0; i < 16; ++i)
                {
                    set_sprite_tile(enemy2x2.ids[i], 0);
                }
            }
            else 
            {
                for(i = 0; i < 16; ++i)
                {
                    set_sprite_tile(enemy4x4.ids[i], 0);
                }
            }
              
            battleState = 0;
            MoveMetaSprite2x2(&door, door.rect.x, door.rect.y + 3);
            for(i = 0; i < 4; ++i)
            {
                set_sprite_tile(door.ids[i], 0);
            }
                
        }
    }
}

void DisplayHp()
{
    UINT8ToText(health, &numberChars);
    for(i = 0; i < 3; ++i)
    {
        BattleWindowMap[i+2] = numberChars[i];
    }

    UINT8ToText(enemyHealth, &numberChars);
    for(i = 0; i < 3; ++i)
    {
        BattleWindowMap[i+7] = numberChars[i];
    }

    set_win_tiles(0,0,20,1, BattleWindowMap);
}

void DisplayShopHp()
{
    UINT8ToText(health, &numberChars);
    for(i = 0; i < 3; ++i)
    {
        set_sprite_tile(hpSprites[i].id, numberChars[i]-123);
    }

    UINT8ToText(sacrifice, &numberChars);
    for(i = 0; i < 3; ++i)
    {
        set_sprite_tile(sacrificeSprites[i].id, numberChars[i]-123);
    }
}

void EndBattle()
{
    HIDE_WIN;
    for(i = 0; i < 39; ++i) set_sprite_tile(i, 0);
}