#include <gb/gb.h>
#include "Helpers.c"
#include "SpriteSystem.c"
#include "TileData/BattleTiles.c"
#include "TileData/ShopSelectionTiles.c"
#include "TileData/ShopTiles.c"
#include "TileData/ShopBG.c"
#include "TileData/TitleBG2_data.c"
#include "TileData/TitleBG2_map.c"
#include "TileData/DieBG.c"
#include "TileData/LoreBG.c"
#include "TileData/WinBG.c"
#include "TileData/BattleBGTiles.c"
#include "TileData/BattleBGMap.c"
#include "TileData/BattleBGMap2.c"
#include "TileData/Alpha.c"
#include "TileData/EnemyTiles1.c"
#include "TileData/EnemyTiles2.c"

#ifndef MAIN
#define MAIN

MetaSprite1x2 selectionLeft;
//MetaSprite1x2 selectionRight; This is weaponSpearVer

Sprite hpSprites[3];
Sprite sacrificeSprites[3];

MetaSprite2x2 door;
MetaSprite2x2 player;
MetaSprite2x2 enemy2x2;
MetaSprite4x4 enemy4x4;
Sprite weaponDagger;
MetaSprite2x1 weaponSpearHor;
MetaSprite1x2 weaponSpearVer;
MetaSprite2x2 weaponSword;

// UP, LEFT, DOWN, RIGHT
UINT8 playerDirection;
const UINT8 PLAYER_SPEED = 2;
const UINT8 PLAYER_DASH_SPEED = 5;
UINT8 dashFrames;
UINT8 attackFrames;
UINT8 animFrame;
UINT8 damageFrames;

UINT8 sacrifice = 250;
UINT8 health = 50;
const UINT8 maxHealth = 100;
UINT8 currentSelection; // Item in shop, weapon in battle
UINT8 weaponsUnlocked = 2;
UINT8 battleNo = 2;
UINT8 battleState = 0;

UINT8 enemyDirTimer;
UINT8 enemyPosX;
UINT8 enemyPosY;
const UINT8 ENEMY1_SPEED = 1;
const UINT8 ENEMY2_SPEED = 2;
UINT8 enemyHealth;
UINT8 enemyDirection;
UINT8 enemyDamageFrames;

UINT8 stageScrollX;
UINT8 stageScrollY;
const UINT8 battleStageMinX = 23;
const UINT8 battleStageMaxX = 234;
const UINT8 battleStageMinY = 47;
const UINT8 battleStageMaxY = 240;

// 0: Title
// 1: Lore
// 2: Shop
// 3: Battle
// 4: Game Over
// 5: Outro
UINT8 gameState;

const UINT8 START_POS = 80;
const UINT8 ENEMY_START_POS = 180;

const UINT8 BATTLE_NO_HPS[3] = {50, 100, 150};
const UINT8 BATTLE_NO_DIRS[3] = {5, 8, 10};
const UINT8 BATTLE_NO_WALKS[3] = {8, 4, 6};

unsigned char numberChars[3] = {0x9B,0x9B,0x9B};
unsigned char BattleWindowMap[] =
{
    0x80,0xA5,0x80,0x80,0x80,0x80,0xA5,0x80,0x80,0x80,
    0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
};

const UINT8 DINO_UP1[16] =
{
    0,59,60,0,
    0,61,62,0,
    0,63,64,0,
    0,65,66,0
};

const UINT8 DINO_DOWN1[16] =
{
    0,67,68,0,
    0,69,70,0,
    0,71,72,0,
    0,73,74,0
};

const UINT8 DINO_LEFT1[16] =
{
    0,0,75,76,
    77,78,79,80,
    81,82,83,0,
    84,85,86,0
};

const UINT8 DINO_LEFT2[16] =
{
    0,0,87,88,
    89,90,91,92,
    93,94,95,0,
    96,97,98,0
};

void main();
void LoadTitle();
void LoadLore();
void LoadShop();
void LoadBattle();
void LoadGameOver();
void LoadOutro();
void ShopLoop();
void MoveShopSelection();
void BattleLoop();
void PlayerLoop();
void MovePlayer(UINT8 speed);
void IdlePlayer();
void TakeDamage(UINT8 amount);
void EnemyLoop();
void MoveEnemy2x2(UINT8 speed);
void MoveEnemy4x4(UINT8 speed);
void EnemyDirTowardsPlayer();
void EnemyTakeDamage(UINT8 amount);
void DisplayHp();
void DisplayShopHp();
void EndBattle();

#endif